package com.xxfc.platform.campsite.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import java.io.Serializable;
import java.util.Objects;


/**
 * 营地店铺表
 *
 * @author libin
 * @email 18178966185@163.com
 * @date 2019-06-17 10:28:48
 */
@Data
@ApiModel(value = "营地店铺vo")
public class CampsiteShopPageDTO implements Serializable {
    private static final long serialVersionUID = 1L;


    @ApiModelProperty("主键id")
    private Integer id;

    /**
     * 店铺名称
     */
    @ApiModelProperty(value = "店铺名称")
    private String name;

    /**
     * 店铺logo
     */
    @ApiModelProperty(value = "店铺logo")
    private String logo;

    /**
     * 店铺URL
     */
    @ApiModelProperty(value = "店铺URL")
    private String url;

    /**
     * 地址-省/直辖市(名称)
     */
    @ApiModelProperty(value = "地址-省/直辖市(名称)")
    private String provinceName;

    /**
     * 地址-市(名称)
     */
    @ApiModelProperty(value = "地址-市(名称)")
    private String cityName;

    /**
     * 店铺类型名称
     */
    @ApiModelProperty(value = "店铺类型名称")
    private String  storeTypeName;

    /**
     * 店铺类型id
     */
    @ApiModelProperty(value = "店铺类型id")
    private String storeId;
    /**
     * 经度
     */
    @Column(name = "longitude")
    @ApiModelProperty(value = "经度")
    private Double longitude;

    /**
     * 纬度
     */
    @Column(name = "latitude")
    @ApiModelProperty(value = "纬度")
    private Double latitude;

    /**
     * 热度值
     */
    @ApiModelProperty(value = "热度值")
    private Integer hot;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间", hidden = true)
    private Long crtTime;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        CampsiteShopPageDTO that = (CampsiteShopPageDTO) o;
        return Objects.equals(id, that.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }
}
